require '_h2ph_pre.ph';

no warnings 'redefine';

if(defined(&__KERNEL__)) {
    unless(defined(&_PPC_BITOPS_H)) {
	eval 'sub _PPC_BITOPS_H () {1;}' unless defined(&_PPC_BITOPS_H);
	require 'linux/config.ph';
	require 'asm/byteorder.ph';
	require 'asm/atomic.ph';
	if(defined(&CONFIG_SMP)) {
	    eval 'sub SMP_WMB () {"eieio\\n";}' unless defined(&SMP_WMB);
	    eval 'sub SMP_MB () {"\\nsync";}' unless defined(&SMP_MB);
	} else {
	    eval 'sub SMP_WMB () {1;}' unless defined(&SMP_WMB);
	    eval 'sub SMP_MB () {1;}' unless defined(&SMP_MB);
	}
	eval 'sub smp_mb__before_clear_bit () {
	    eval q( &smp_mb());
	}' unless defined(&smp_mb__before_clear_bit);
	eval 'sub smp_mb__after_clear_bit () {
	    eval q( &smp_mb());
	}' unless defined(&smp_mb__after_clear_bit);
	eval 'sub clear_bit {
	    my($nr,$addr) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&clear_bit);
	eval 'sub change_bit {
	    my($nr,$addr) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&change_bit);
	eval 'sub test_and_clear_bit {
	    my($nr,$addr) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&test_and_clear_bit);
	eval 'sub test_and_change_bit {
	    my($nr,$addr) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&test_and_change_bit);
	eval 'sub test_bit {
	    my($nr,$addr) = @_;
    	    eval q({  &__const__ my $int * &p = ( &__const__ my $int *) $addr; (( $p[$nr >> 5] >> ($nr & 0x1f)) & 1) != 0; });
	}' unless defined(&test_bit);
	eval 'sub ffz {
	    my($x) = @_;
    	    eval q({  &if (($x = ~$x) == 0) 32;  &__ilog2($x & -$x); });
	}' unless defined(&ffz);
	eval 'sub hweight32 {
	    my($x) = @_;
    	    eval q( &generic_hweight32($x));
	}' unless defined(&hweight32);
	eval 'sub hweight16 {
	    my($x) = @_;
    	    eval q( &generic_hweight16($x));
	}' unless defined(&hweight16);
	eval 'sub hweight8 {
	    my($x) = @_;
    	    eval q( &generic_hweight8($x));
	}' unless defined(&hweight8);
	eval 'sub find_first_zero_bit {
	    my($addr, $size) = @_;
    	    eval q( &find_next_zero_bit(($addr), ($size), 0));
	}' unless defined(&find_first_zero_bit);
	eval 'sub find_next_zero_bit {
	    my($addr,$size,$offset) = @_;
    	    eval q({ my $int *  &p = ( $addr) + ($offset >> 5); my $result = $offset & ~31; my $tmp;  &if ($offset >= $size) $size; $size -=  $result; $offset &= 31;  &if ($offset) {  $tmp = * &p++;  $tmp |= ~0 >> (32-$offset);  &if ($size < 32)  &goto  &found_first;  &if ( $tmp != ~0)  &goto  &found_middle; $size -= 32;  $result += 32; }  &while ($size >= 32) {  &if (( $tmp = * &p++) != ~0)  &goto  &found_middle;  $result += 32; $size -= 32; }  &if (!$size)  $result;  $tmp = * &p;  &found_first:  $tmp |= ~0 << $size;  &if ( $tmp == ~0)  $result + $size;  &found_middle:  $result +  &ffz( $tmp); });
	}' unless defined(&find_next_zero_bit);
	eval 'sub ext2_set_bit {
	    my($nr, $addr) = @_;
    	    eval q( &__test_and_set_bit(($nr) ^ 0x18, $addr));
	}' unless defined(&ext2_set_bit);
	eval 'sub ext2_clear_bit {
	    my($nr, $addr) = @_;
    	    eval q( &__test_and_clear_bit(($nr) ^ 0x18, $addr));
	}' unless defined(&ext2_clear_bit);
	eval 'sub ext2_test_bit {
	    my($nr,$addr) = @_;
    	    eval q({  &__const__ my $char * &ADDR = ( &__const__ my $char *) $addr; ( $ADDR[$nr >> 3] >> ($nr & 7)) & 1; });
	}' unless defined(&ext2_test_bit);
	eval 'sub ext2_find_first_zero_bit {
	    my($addr, $size) = @_;
    	    eval q( &ext2_find_next_zero_bit(($addr), ($size), 0));
	}' unless defined(&ext2_find_first_zero_bit);
	eval 'sub ext2_find_next_zero_bit {
	    my($addr,$size,$offset) = @_;
    	    eval q({ my $int * &p = ( $addr) + ($offset >> 5); my $result = $offset & ~31; my $tmp;  &if ($offset >= $size) $size; $size -=  $result; $offset &= 31;  &if ($offset) {  $tmp =  &cpu_to_le32p( &p++);  $tmp |= ~0 >> (32-$offset);  &if ($size < 32)  &goto  &found_first;  &if ( $tmp != ~0)  &goto  &found_middle; $size -= 32;  $result += 32; }  &while ($size >= 32) {  &if (( $tmp =  &cpu_to_le32p( &p++)) != ~0)  &goto  &found_middle;  $result += 32; $size -= 32; }  &if (!$size)  $result;  $tmp =  &cpu_to_le32p( &p);  &found_first:  $tmp |= ~0 << $size;  &if ( $tmp == ~0)  $result + $size;  &found_middle:  $result +  &ffz( $tmp); });
	}' unless defined(&ext2_find_next_zero_bit);
	eval 'sub minix_test_and_set_bit {
	    my($nr,$addr) = @_;
    	    eval q( &ext2_set_bit($nr,$addr));
	}' unless defined(&minix_test_and_set_bit);
	eval 'sub minix_set_bit {
	    my($nr,$addr) = @_;
    	    eval q((( &void) &ext2_set_bit($nr,$addr)));
	}' unless defined(&minix_set_bit);
	eval 'sub minix_test_and_clear_bit {
	    my($nr,$addr) = @_;
    	    eval q( &ext2_clear_bit($nr,$addr));
	}' unless defined(&minix_test_and_clear_bit);
	eval 'sub minix_test_bit {
	    my($nr,$addr) = @_;
    	    eval q( &ext2_test_bit($nr,$addr));
	}' unless defined(&minix_test_bit);
	eval 'sub minix_find_first_zero_bit {
	    my($addr,$size) = @_;
    	    eval q( &ext2_find_first_zero_bit($addr,$size));
	}' unless defined(&minix_find_first_zero_bit);
    }
}
1;
