require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_PPC_PAGE_H)) {
    eval 'sub _PPC_PAGE_H () {1;}' unless defined(&_PPC_PAGE_H);
    eval 'sub PAGE_SHIFT () {12;}' unless defined(&PAGE_SHIFT);
    eval 'sub PAGE_SIZE () {(1 <<  &PAGE_SHIFT);}' unless defined(&PAGE_SIZE);
    eval 'sub PAGE_MASK () {(~((1<<  &PAGE_SHIFT) - 1));}' unless defined(&PAGE_MASK);
    if(defined(&__KERNEL__)) {
	require 'linux/config.ph';
	eval 'sub PAGE_OFFSET () { &CONFIG_KERNEL_START;}' unless defined(&PAGE_OFFSET);
	eval 'sub KERNELBASE () { &PAGE_OFFSET;}' unless defined(&KERNELBASE);
	unless(defined(&__ASSEMBLY__)) {
	    if(defined(&CONFIG_PTE_64BIT)) {
		eval 'sub PTE_SHIFT () {( &PAGE_SHIFT - 3);}' unless defined(&PTE_SHIFT);
		eval 'sub PTE_FMT () {"%16Lx";}' unless defined(&PTE_FMT);
	    } else {
		eval 'sub PTE_SHIFT () {( &PAGE_SHIFT - 2);}' unless defined(&PTE_SHIFT);
		eval 'sub PTE_FMT () {"%.8lx";}' unless defined(&PTE_FMT);
	    }
	    require 'asm/system.ph';
	    if(defined(&CONFIG_XMON)) {
		eval 'sub BUG () {
		    eval q( &do {  &printk(\\"kernel BUG at %s:%d!\\\\n\\",  &__FILE__,  &__LINE__);  &xmon(0); }  &while (0));
		}' unless defined(&BUG);
	    } else {
		eval 'sub BUG () {
		    eval q(\\"(assembly code)\\");
		}' unless defined(&BUG);
	    }
	    eval 'sub PAGE_BUG {
	        my($page) = @_;
    		eval q( &do {  &BUG(); }  &while (0));
	    }' unless defined(&PAGE_BUG);
	    eval 'sub STRICT_MM_TYPECHECKS () {1;}' unless defined(&STRICT_MM_TYPECHECKS);
	    if(defined(&STRICT_MM_TYPECHECKS)) {
		eval 'sub pte_val {
		    my($x) = @_;
    		    eval q((($x). &pte));
		}' unless defined(&pte_val);
		eval 'sub pmd_val {
		    my($x) = @_;
    		    eval q((($x). &pmd));
		}' unless defined(&pmd_val);
		eval 'sub pgd_val {
		    my($x) = @_;
    		    eval q((($x). &pgd));
		}' unless defined(&pgd_val);
		eval 'sub pgprot_val {
		    my($x) = @_;
    		    eval q((($x). &pgprot));
		}' unless defined(&pgprot_val);
		eval 'sub __pte {
		    my($x) = @_;
    		    eval q((( &pte_t) { ($x) } ));
		}' unless defined(&__pte);
		eval 'sub __pmd {
		    my($x) = @_;
    		    eval q((( &pmd_t) { ($x) } ));
		}' unless defined(&__pmd);
		eval 'sub __pgd {
		    my($x) = @_;
    		    eval q((( &pgd_t) { ($x) } ));
		}' unless defined(&__pgd);
		eval 'sub __pgprot {
		    my($x) = @_;
    		    eval q((( &pgprot_t) { ($x) } ));
		}' unless defined(&__pgprot);
	    } else {
		eval 'sub pte_val {
		    my($x) = @_;
    		    eval q(($x));
		}' unless defined(&pte_val);
		eval 'sub pmd_val {
		    my($x) = @_;
    		    eval q(($x));
		}' unless defined(&pmd_val);
		eval 'sub pgd_val {
		    my($x) = @_;
    		    eval q(($x));
		}' unless defined(&pgd_val);
		eval 'sub pgprot_val {
		    my($x) = @_;
    		    eval q(($x));
		}' unless defined(&pgprot_val);
		eval 'sub __pte {
		    my($x) = @_;
    		    eval q(($x));
		}' unless defined(&__pte);
		eval 'sub __pmd {
		    my($x) = @_;
    		    eval q(($x));
		}' unless defined(&__pmd);
		eval 'sub __pgd {
		    my($x) = @_;
    		    eval q(($x));
		}' unless defined(&__pgd);
		eval 'sub __pgprot {
		    my($x) = @_;
    		    eval q(($x));
		}' unless defined(&__pgprot);
	    }
	    eval 'sub _ALIGN {
	        my($addr,$size) = @_;
    		eval q(((($addr)+($size)-1)(~(($size)-1))));
	    }' unless defined(&_ALIGN);
	    eval 'sub PAGE_ALIGN {
	        my($addr) = @_;
    		eval q(((($addr)+ &PAGE_SIZE-1) &PAGE_MASK));
	    }' unless defined(&PAGE_ALIGN);
	    unless(defined(&CONFIG_APUS)) {
		eval 'sub PPC_MEMSTART () {0;}' unless defined(&PPC_MEMSTART);
		eval 'sub PPC_MEMOFFSET () { &PAGE_OFFSET;}' unless defined(&PPC_MEMOFFSET);
	    } else {
		eval 'sub PPC_MEMSTART () { &ppc_memstart;}' unless defined(&PPC_MEMSTART);
		eval 'sub PPC_MEMOFFSET () { &ppc_memoffset;}' unless defined(&PPC_MEMOFFSET);
	    }
	    if(defined( &CONFIG_APUS)  && !defined( &MODULE)) {
		eval 'sub ___va {
		    my($p) = @_;
    		    eval q({ my $v;  &asm  &volatile (\\"1: addis %0, %1, %2;\\" \\".section \\\\\\".ptov_fixup\\\\\\",\\\\\\"aw\\\\\\";\\" \\".align  1;\\" \\".long   1b;\\" \\".previous;\\" : \\"=r\\" ( $v) : \\"b\\" ($p), \\"K\\" ((( &PAGE_OFFSET) >> 16) & 0xffff)); ( &void*)  $v; });
		}' unless defined(&___va);
	    } else {
		eval 'sub ___pa {
		    my($vaddr) = @_;
    		    eval q((($vaddr)- &PPC_MEMOFFSET));
		}' unless defined(&___pa);
		eval 'sub ___va {
		    my($paddr) = @_;
    		    eval q((($paddr)+ &PPC_MEMOFFSET));
		}' unless defined(&___va);
	    }
	    eval 'sub __pa {
	        my($x) = @_;
    		eval q( &___pa(($x)));
	    }' unless defined(&__pa);
	    eval 'sub __va {
	        my($x) = @_;
    		eval q((( &void *)( &___va(($x)))));
	    }' unless defined(&__va);
	    eval 'sub MAP_PAGE_RESERVED () {(1<<15);}' unless defined(&MAP_PAGE_RESERVED);
	    eval 'sub virt_to_page {
	        my($kaddr) = @_;
    		eval q(( &mem_map + ((($kaddr)- &PAGE_OFFSET) >>  &PAGE_SHIFT)));
	    }' unless defined(&virt_to_page);
	    eval 'sub VALID_PAGE {
	        my($page) = @_;
    		eval q(((($page) -  &mem_map) <  &max_mapnr));
	    }' unless defined(&VALID_PAGE);
	}
	eval 'sub VM_DATA_DEFAULT_FLAGS () {( &VM_READ |  &VM_WRITE |  &VM_EXEC |  &VM_MAYREAD |  &VM_MAYWRITE |  &VM_MAYEXEC);}' unless defined(&VM_DATA_DEFAULT_FLAGS);
    }
}
1;
