require '_h2ph_pre.ph';

no warnings 'redefine';

if(defined(&__KERNEL__)) {
    unless(defined(&_PPC_PGALLOC_H)) {
	eval 'sub _PPC_PGALLOC_H () {1;}' unless defined(&_PPC_PGALLOC_H);
	require 'linux/config.ph';
	require 'linux/threads.ph';
	require 'asm/processor.ph';
	if(defined(&CONFIG_PTE_64BIT)) {
	    eval 'sub PGDIR_ORDER () {1;}' unless defined(&PGDIR_ORDER);
	} else {
	    eval 'sub PGDIR_ORDER () {0;}' unless defined(&PGDIR_ORDER);
	}
	if(defined(&CONFIG_SMP)) {
	    eval 'sub quicklists () { $cpu_data[ &smp_processor_id()];}' unless defined(&quicklists);
	} else {
	}
	eval 'sub pgd_quicklist () {( ($quicklists->{pgd_cache}));}' unless defined(&pgd_quicklist);
	eval 'sub pmd_quicklist () {(0);}' unless defined(&pmd_quicklist);
	eval 'sub pte_quicklist () {( ($quicklists->{pte_cache}));}' unless defined(&pte_quicklist);
	eval 'sub pgtable_cache_size () {( ($quicklists->{pgtable_cache_sz}));}' unless defined(&pgtable_cache_size);
	eval 'sub zero_quicklist () {( &zero_cache);}' unless defined(&zero_quicklist);
	eval 'sub zero_cache_sz () {( &zero_sz);}' unless defined(&zero_cache_sz);
	eval 'sub zero_cache_calls () {( &zeropage_calls);}' unless defined(&zero_cache_calls);
	eval 'sub zero_cache_hits () {( &zeropage_hits);}' unless defined(&zero_cache_hits);
	eval 'sub zero_cache_total () {( &zerototal);}' unless defined(&zero_cache_total);
	eval 'sub pgd_t {
	    eval q(* &get_pgd_slow( &void) {  &pgd_t * &ret;  &if (( &ret = ( &pgd_t *) &__get_free_pages( &GFP_KERNEL,  &PGDIR_ORDER)) !=  &NULL)  &clear_page( &ret);  &ret; });
	}' unless defined(&pgd_t);
	eval 'sub pgd_t {
	    eval q(* &get_pgd_fast { my $long * &ret;  &if (( &ret =  &pgd_quicklist) !=  &NULL) {  &pgd_quicklist = (* &ret);  $ret[0] = 0;  &pgtable_cache_size--; }  &else  &ret =  &get_pgd_slow(); ( &pgd_t *) &ret; });
	}' unless defined(&pgd_t);
	eval 'sub free_pgd_fast {
	    my($pgd) = @_;
    	    eval q({ *$pgd =  &pgd_quicklist;  &pgd_quicklist = $pgd;  &pgtable_cache_size++; });
	}' unless defined(&free_pgd_fast);
	eval 'sub free_pgd_slow {
	    my($pgd) = @_;
    	    eval q({  &free_page($pgd); });
	}' unless defined(&free_pgd_slow);
	eval 'sub pgd_free {
	    my($pgd) = @_;
    	    eval q( &free_pgd_fast($pgd));
	}' unless defined(&pgd_free);
	eval 'sub pgd_alloc {
	    my($mm) = @_;
    	    eval q( &get_pgd_fast());
	}' unless defined(&pgd_alloc);
	eval 'sub pmd_alloc_one_fast {
	    my($mm, $address) = @_;
    	    eval q(({  &BUG(); (( &pmd_t *)1); }));
	}' unless defined(&pmd_alloc_one_fast);
	eval 'sub pmd_alloc_one {
	    my($mm,$address) = @_;
    	    eval q(({  &BUG(); (( &pmd_t *)2); }));
	}' unless defined(&pmd_alloc_one);
	eval 'sub pmd_free {
	    my($x) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&pmd_free);
	eval 'sub pgd_populate {
	    my($mm, $pmd, $pte) = @_;
    	    eval q( &BUG());
	}' unless defined(&pgd_populate);
	eval 'sub pte_t {
	    eval q(* &pte_alloc_one(\'struct mm_struct\' * &mm, my $address) {  &pte_t * &pte; \'int\'  &mem_init_done;  &void * &early_get_page( &void);  &if ( &mem_init_done)  &pte = ( &pte_t *)  &__get_free_page( &GFP_KERNEL);  &else  &pte = ( &pte_t *)  &early_get_page();  &if ( &pte !=  &NULL)  &clear_page( &pte);  &pte; });
	}' unless defined(&pte_t);
	eval 'sub pte_t {
	    eval q(* &pte_alloc_one_fast(\'struct mm_struct\' * &mm, my $address) { my $long * &ret;  &if (( &ret =  &pte_quicklist) !=  &NULL) {  &pte_quicklist = (* &ret);  $ret[0] = 0;  &pgtable_cache_size--; } ( &pte_t *) &ret; });
	}' unless defined(&pte_t);
	eval 'sub pte_free_fast {
	    my($pte) = @_;
    	    eval q({ *$pte =  &pte_quicklist;  &pte_quicklist = $pte;  &pgtable_cache_size++; });
	}' unless defined(&pte_free_fast);
	eval 'sub pte_free_slow {
	    my($pte) = @_;
    	    eval q({  &free_page($pte); });
	}' unless defined(&pte_free_slow);
	eval 'sub pte_free {
	    my($pte) = @_;
    	    eval q( &pte_free_slow($pte));
	}' unless defined(&pte_free);
	eval 'sub pmd_populate {
	    my($mm, $pmd, $pte) = @_;
    	    eval q(( &pmd_val(*) = ($pte)));
	}' unless defined(&pmd_populate);
    }
}
1;
