require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__PPC_SYSTEM_H)) {
    eval 'sub __PPC_SYSTEM_H () {1;}' unless defined(&__PPC_SYSTEM_H);
    require 'linux/config.ph';
    require 'linux/kdev_t.ph';
    require 'asm/processor.ph';
    require 'asm/atomic.ph';
    require 'asm/hw_irq.ph';
    eval 'sub mb () {
        eval q(\\"(assembly code)\\");
    }' unless defined(&mb);
    eval 'sub rmb () {
        eval q(\\"(assembly code)\\");
    }' unless defined(&rmb);
    eval 'sub wmb () {
        eval q(\\"(assembly code)\\");
    }' unless defined(&wmb);
    eval 'sub set_mb {
        my($var, $value) = @_;
	    eval q( &do { $var = $value;  &mb(); }  &while (0));
    }' unless defined(&set_mb);
    eval 'sub set_wmb {
        my($var, $value) = @_;
	    eval q( &do { $var = $value;  &wmb(); }  &while (0));
    }' unless defined(&set_wmb);
    if(defined(&CONFIG_SMP)) {
	eval 'sub smp_mb () {
	    eval q( &mb());
	}' unless defined(&smp_mb);
	eval 'sub smp_rmb () {
	    eval q( &rmb());
	}' unless defined(&smp_rmb);
	eval 'sub smp_wmb () {
	    eval q( &wmb());
	}' unless defined(&smp_wmb);
    } else {
	eval 'sub smp_mb () {
	    eval q(\\"(assembly code)\\");
	}' unless defined(&smp_mb);
	eval 'sub smp_rmb () {
	    eval q(\\"(assembly code)\\");
	}' unless defined(&smp_rmb);
	eval 'sub smp_wmb () {
	    eval q(\\"(assembly code)\\");
	}' unless defined(&smp_wmb);
    }
    if(defined(&__KERNEL__)) {
	if(defined(&CONFIG_6xx)) {
	} else {
	    eval 'sub _get_L2CR () {
	        eval q(0);
	    }' unless defined(&_get_L2CR);
	    eval 'sub _set_L2CR {
	        my($val) = @_;
    		eval q( &do { }  &while(0));
	    }' unless defined(&_set_L2CR);
	    eval 'sub _get_L3CR () {
	        eval q(0);
	    }' unless defined(&_get_L3CR);
	    eval 'sub _set_L3CR {
	        my($val) = @_;
    		eval q( &do { }  &while(0));
	    }' unless defined(&_set_L3CR);
	}
	eval 'sub prepare_to_switch () {
	    eval q( &do { }  &while(0));
	}' unless defined(&prepare_to_switch);
	eval 'sub switch_to {
	    my($prev,$next,$last) = @_;
    	    eval q( &_switch_to(($prev),($next),($last)));
	}' unless defined(&switch_to);
	unless(defined(&CONFIG_SMP)) {
	    eval 'sub cli () {
	        eval q( &__cli());
	    }' unless defined(&cli);
	    eval 'sub sti () {
	        eval q( &__sti());
	    }' unless defined(&sti);
	    eval 'sub save_flags {
	        my($flags) = @_;
    		eval q( &__save_flags($flags));
	    }' unless defined(&save_flags);
	    eval 'sub restore_flags {
	        my($flags) = @_;
    		eval q( &__restore_flags($flags));
	    }' unless defined(&restore_flags);
	    eval 'sub save_and_cli {
	        my($flags) = @_;
    		eval q( &__save_and_cli($flags));
	    }' unless defined(&save_and_cli);
	    eval 'sub save_and_sti {
	        my($flags) = @_;
    		eval q( &__save_and_sti($flags));
	    }' unless defined(&save_and_sti);
	} else {
	    eval 'sub cli () {
	        eval q( &__global_cli());
	    }' unless defined(&cli);
	    eval 'sub sti () {
	        eval q( &__global_sti());
	    }' unless defined(&sti);
	    eval 'sub save_flags {
	        my($x) = @_;
    		eval q((($x)= &__global_save_flags()));
	    }' unless defined(&save_flags);
	    eval 'sub restore_flags {
	        my($x) = @_;
    		eval q( &__global_restore_flags($x));
	    }' unless defined(&restore_flags);
	    eval 'sub save_and_cli {
	        my($x) = @_;
    		eval q( &do {  &save_flags($x);  &cli(); }  &while(0););
	    }' unless defined(&save_and_cli);
	    eval 'sub save_and_sti {
	        my($x) = @_;
    		eval q( &do {  &save_flags($x);  &sti(); }  &while(0););
	    }' unless defined(&save_and_sti);
	}
	eval 'sub local_irq_disable () {
	    eval q( &__cli());
	}' unless defined(&local_irq_disable);
	eval 'sub local_irq_enable () {
	    eval q( &__sti());
	}' unless defined(&local_irq_enable);
	eval 'sub local_irq_save {
	    my($flags) = @_;
    	    eval q( &__save_and_cli($flags));
	}' unless defined(&local_irq_save);
	eval 'sub local_irq_set {
	    my($flags) = @_;
    	    eval q( &__save_and_sti($flags));
	}' unless defined(&local_irq_set);
	eval 'sub local_irq_restore {
	    my($flags) = @_;
    	    eval q( &__restore_flags($flags));
	}' unless defined(&local_irq_restore);
	eval 'sub xchg_u32 {
	    my($p,$val) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&xchg_u32);
	eval 'sub xchg {
	    my($ptr,$x) = @_;
    	    eval q((( &__typeof__(*)) &__xchg(($x),($ptr),$sizeof{($ptr)})));
	}' unless defined(&xchg);
	eval 'sub tas {
	    my($ptr) = @_;
    	    eval q(( &xchg(($ptr),1)));
	}' unless defined(&tas);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub __xchg {
	    my($x,$ptr,$size) = @_;
    	    eval q({  &switch {  &case 4:  &xchg_u32($ptr, $x); }  &__xchg_called_with_bad_pointer(); $x; });
	}' unless defined(&__xchg);
	eval 'sub __HAVE_ARCH_CMPXCHG () {1;}' unless defined(&__HAVE_ARCH_CMPXCHG);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub __cmpxchg_u32 {
	    my($p,$old,$new) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__cmpxchg_u32);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub __cmpxchg {
	    my($ptr,$old,$new,$size) = @_;
    	    eval q({  &switch ($size) {  &case 4:  &__cmpxchg_u32($ptr, $old, $new); }  &__cmpxchg_called_with_bad_pointer(); $old; });
	}' unless defined(&__cmpxchg);
	eval 'sub cmpxchg {
	    my($ptr,$o,$n) = @_;
    	    eval q(({  &__typeof__(*)  &_o_ = ;  &__typeof__(*)  &_n_ = ; ( &__typeof__(*))  &__cmpxchg(,  &_o_,  &_n_, $sizeof{($ptr)}); }));
	}' unless defined(&cmpxchg);
    }
}
1;
